package com.glxp.udidl.admin.service.sys.impl;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.glxp.udidl.admin.dao.sys.SysRoleMapper;
import com.glxp.udidl.admin.dto.sys.SysRoleModel;
import com.glxp.udidl.admin.dto.sys.SysRoleParam;
import com.glxp.udidl.admin.entity.sys.SysRole;
import com.glxp.udidl.admin.res.PageSimpleResponse;
import com.glxp.udidl.admin.service.sys.SysRoleService;
import com.glxp.udidl.common.res.BaseResponse;
import com.glxp.udidl.common.util.ResultVOUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;

@Service
public class SysRoleServiceImpl implements SysRoleService {
    @Autowired
    SysRoleMapper mapper;

    @Override
    public BaseResponse list(SysRoleParam param) {
        PageHelper.startPage(param.getPage(), param.getLimit());
        List<SysRole> list = mapper.list(param);
        PageInfo<SysRole> pageInfo = new PageInfo<>(list);
        PageSimpleResponse<SysRole> pageSimpleResponse = new PageSimpleResponse<>();
        pageSimpleResponse.setTotal(pageInfo.getTotal());
        pageSimpleResponse.setList(list);
        return ResultVOUtils.success(pageSimpleResponse);
    }

    @Override
    public BaseResponse insert(SysRoleModel model) {
        SysRole sysRole = new SysRole();
        BeanUtils.copyProperties(model, sysRole);
        sysRole.setCreateTime(new Date());
        mapper.insert(sysRole);
        return ResultVOUtils.success();
    }

    @Override
    public BaseResponse update(SysRoleModel model) {
        SysRole sysRole = mapper.selectByPrimaryKey(model.getId());
        if (sysRole == null)
            return ResultVOUtils.error(-1, "找不到记录");
        BeanUtils.copyProperties(model, sysRole);
        mapper.updateByPrimaryKey(sysRole);
        return ResultVOUtils.success();
    }

    @Override
    public BaseResponse detail(Integer id) {
        SysRole sysRole = mapper.selectByPrimaryKey(id);
        if (sysRole == null)
            return ResultVOUtils.error(-1, "找不到记录");
        return ResultVOUtils.success(sysRole);
    }

    @Override
    public BaseResponse delete(Integer id) {
        mapper.deleteByPrimaryKey(id);
        return ResultVOUtils.success();
    }
}
